/**
 * @file        interface.h
 * @brief       API interface server

 * Copyright (c) 2017 Samsung Electronics Co., Ltd.
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */

#ifndef __IPC_SERVER_H__
#define __IPC_SERVER_H__

#ifdef __cplusplus
extern "C" {
#endif
/**
 * @fn        int IPC_StartServer(char *(*pFunc)(char *, int))
 * @brief     this function to start IPC Server
 * @param     char *(*pFunc)(char *, int)
 * @return    int
 */
	int IPC_StartServer(char *(*pFunc) (char *, int));

/**
 * @fn        int callback_init_connection(void)
 * @brief     this function to initialize callback fuction
 * @param     void
 * @return    int
 */
	int callback_init_connection(void);

#ifdef __cplusplus
}
#endif
#endif							/* __IPC_SERVER_H__ */
