#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <pthread.h>

#include "../ipc.h"
#include "../ipc_config.h"

#define RST		printf("\033[0m")
#define RED		printf("\033[0;31m")
#define GREEN	printf("\033[0;32m")
#define BLUE	printf("\033[0;34m")
#define IRED	printf("\033[1;91m")
#define IGREEN	printf("\033[1;92m")
#define IBLUE	printf("\033[1;94m")
#define BRED	printf("\033[0;101m")
#define BGREEN	printf("\033[0;102m")
#define BBLUE	printf("\033[0;104m")

#define NORMAL	IBLUE
#define ERR		BBLUE
#define DATA  BLUE

#define _D(fmt, ...) do {NORMAL; printf(fmt, ##__VA_ARGS__); RST; } while (0)
#define _DATA(fmt, ...) do {DATA; printf(fmt, ##__VA_ARGS__); RST; } while (0)
#define _ERR(fmt, ...) do {ERR; printf(fmt, ##__VA_ARGS__); RST; } while (0)

static SOCKET_HANDLE __cbhndl;
static SOCKET_HANDLE *__pcbhndl = NULL;

static int __send_callback_event(void *data)
{
	int ret = -1;
	if (__pcbhndl && data)
		ret = IPC_SendMessage(__pcbhndl, data, strlen(data));

	return ret;
}

static int __open_callback_connection(void)
{
	int ret = 0;
	char *buf = NULL;
	int msgSize = 0;
	void *ret_buf = NULL;

	_D("[SERVER-CB] adaptor_server start (%s)\n", EVENT_SERVER);

	ret = IPC_OpenServerConnection(EVENT_SERVER, &__cbhndl);

	_D("[SERVER-CB] IPC_OpenServerConnection (ret=%d)\n", ret);

	if (ret >= 0) {
		__pcbhndl = &__cbhndl;

		ret = IPC_ClientAccept(__pcbhndl);
		_D("[SERVER-CB] IPC_ClientAccept (ret=%d)\n", ret);
		if (0 != ret)
			_ERR("[SERVER-CB] error (%d)\n", ret);
	} else {
		_ERR("[SERVER-CB] servercallback_init_connection open error !!\n");
	}

	return ret;

}

int callback_send_data(void *data)
{
	int ret = 0;
	ret = __send_callback_event(data);
	if (0 != ret)
		_ERR("[SERVER-CB] __send_callback_event Failed\n");

	return ret;
}

int callback_init_connection(void)
{
	int ret = 0;
	_D("[SERVER-CB] callback_thread\n");

	ret = __open_callback_connection();
	if (0 != ret)
		_ERR("[SERVER-CB] __open_callback_connection Failed\n");

	return ret;
}
